#include <iostream>
using namespace std;

// Define a Estrutura N
struct No {
    int valor;      // Valor armazenado
    No * prox;      // Ponteiro para prximo elemento da lista
};

// Percorre a lista, imprimindo cada elemento
void imprimir(No * lista);
// Insere valor no incio da lista
No * inserirInicio(No * lista, int valor);
// Remove elemento do incio da lista
No * removerInicio(No * lista, int &valor);
// Percorre a lista, imprimindo cada elemento mpaar
void imprimirImpares(No * lista);
// Percorre a lista, imprimindo cada elemento divisivel por 5
void imprimirDivisiveisPor5(No * lista);
// Conta os ns e devolve o nmero de ns
int contar(No * lista);
// Busca um valor na fila e triplica seu valor
No * buscarETriplicar(No * lista, int valor);

int main(void) {
    // Declara lista vazia
    No * lista = NULL;
    int val; // Variveis gerais

    do {
        cout << "Digite um valor: ";
        cin >> val;
        if (val > 0) lista = inserirInicio(lista, val);
    } while (val > 0);

    imprimir(lista);
    imprimirImpares(lista);
    imprimirDivisiveisPor5(lista);
    cout << "Numero de nos: " << contar(lista) << endl;
    buscarETriplicar(lista,7);
    imprimir(lista);
}

// Procura o n com um valor especfico e triplica seu valor, retornando ponteiro para o n
No * buscarETriplicar(No * lista, int valor) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Se o valor do n atual for o valor procurado...
        if ( atual->valor == valor ) {
            // Triplica o valor
            atual->valor = atual->valor * 3;
            // Retorna o ponteiro para o n atual
            return atual;
        }
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    // Caso a lista tenha chegado ao fim sem encontrar, retorna NULL
    return NULL;
}

// Conta os ns e devolve o nmero de ns
int contar(No * lista) {
    No * atual; // Ponteiro para "n atual"
    int num; // Contador de ns
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Nmero de ns = 0;
    num = 0;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Conta um n
        num++;
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    return num;
}

// Imprime todos os valores divisveis por 5 de uma lista
void imprimirDivisiveisPor5(No * lista) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Imprime valor do n atual
        if (atual->valor % 5 == 0) cout << atual->valor << ",";
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    cout << endl;
}

// Imprime todos os valores mpares de uma lista
void imprimirImpares(No * lista) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Imprime valor do n atual
        if (atual->valor % 2 == 1) cout << atual->valor << ",";
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    cout << endl;
}

// Imprime todos os valores de uma lista
void imprimir(No * lista) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Imprime valor do n atual
        cout << atual->valor << ",";
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    cout << endl;
}

// Insere um valor no incio da lista
No * inserirInicio(No * lista, int valor) {
    No * tmp; // Ponteiro para armazenar endereo de n temporariamente
    // Cria n
    tmp = new No;
    // Configura n...
    tmp->valor = valor; // Valor do n
    tmp->prox = lista; // Prximo n  o antigo incio da lista
    // Aponta incio da lista para o novo n
    lista = tmp;
    // Retorna o novo incio da lista
    return lista;
}

// Remove um n do incio da lista, retornando seu valor
No * removerInicio(No * lista, int &valor) {
    No * tmp; // Ponteiro temporrio
    // Se a lista est vazia, vai embora
    if (lista == NULL) return NULL;
    // Armazena valor do elemento sendo removido
    valor = lista->valor;
    // Armazena endereo de elemento a ser removido
    tmp = lista;
    // Aponta inicio da lista para segundo elemento
    lista = lista->prox;
    // Remove o primeiro elemento da lista
    delete tmp;
    // Retorna novo incio da lista
    return lista;
}


