#include <iostream>
using namespace std;

// Define a Estrutura N
struct No {
    int valor;      // Valor armazenado
    No * prox;      // Ponteiro para prximo elemento da lista
};

// Insere valor no incio da lista
No * inserirInicio(No * lista, int valor);
// Remove elemento do incio da lista
No * removerInicio(No * lista, int &valor);

#define MAX 100

int main(void) {
    // Declara lista vazia
    No * num = NULL;
    No * oper = NULL;

    // Contador
    int i;
    // Variaveis para clculo
    int a, b, c, op;

    // Expresso
    char exp[MAX];
    // Cada dado da expressao
    int dado;

    // L uma linha de texto
    cout << "Digite uma expressao na notacao infixa:" << endl;
    cin.getline(exp, MAX);

    // Para dada elemento da linha...
    for(i=0; exp[i]!='\0'; i++) {
        // Pega elemento
        dado = exp[i];
        // Se for um dgito
        if (isdigit(dado)) {
            // Corrige o valor (converte de valor ASCII para valor inteiro)
            dado = dado - '0';
            // Empilha na pilha de nmeros
            num = inserirInicio(num,dado);
         }
        else {
            switch(dado) {
                // Se for algum dos operadores, simplesmente empilha
                case '+':
                case '*':
                    oper = inserirInicio(oper,dado);
                    break;
                // Se for fecha parnteses, realiza o clculo
                case ')':
                    // Desempilha valores
                    num = removerInicio(num, a);
                    num = removerInicio(num, b);
                    oper = removerInicio(oper, op);
                    if (op == '+') c = a + b;
                    else if (op == '*') c = a * b;
                    num = inserirInicio(num, c);
                    break;
                // Valores ignorados
                case ' ':
                case '(':
                    break;
                default:
                    cout << "ERRO: Expressao invalida!" << endl;
                    return 1;
            }
        }
    }
    num = removerInicio(num, c);
    cout << "Resultado: " << c << endl;

}

// Insere um valor no incio da lista
No * inserirInicio(No * lista, int valor) {
    No * tmp; // Ponteiro para armazenar endereo de n temporariamente
    // Cria n
    tmp = new No;
    // Configura n...
    tmp->valor = valor; // Valor do n
    tmp->prox = lista; // Prximo n  o antigo incio da lista
    // Aponta incio da lista para o novo n
    lista = tmp;
    // Retorna o novo incio da lista
    return lista;
}

// Remove um n do incio da lista, retornando seu valor
No * removerInicio(No * lista, int &valor) {
    No * tmp; // Ponteiro temporrio
    // Se a lista est vazia, vai embora
    if (lista == NULL) return NULL;
    // Armazena valor do elemento sendo removido
    valor = lista->valor;
    // Armazena endereo de elemento a ser removido
    tmp = lista;
    // Aponta inicio da lista para segundo elemento
    lista = lista->prox;
    // Remove o primeiro elemento da lista
    delete tmp;
    // Retorna novo incio da lista
    return lista;
}

